#version 330


layout(location = 0) out vec4 near_color;
//layout(location = 1) out vec4 focus_color;
layout(location = 1) out vec4 far_color;

in vec2 textPos;

uniform sampler2D colorTexture;
uniform sampler2D depthTexture;

uniform vec4 range;

uniform float near_plane;
uniform float far_plane;

uniform vec4 clear_color;

float linearDepth(float d)
{
  return (2 * near_plane) / (far_plane + near_plane - d * (far_plane - near_plane));
}

void main()
{
  float depth = linearDepth(texture(depthTexture, textPos).r) * 2.0 - 1.0;

  vec4 texColor = texture(colorTexture, textPos);
  vec4 neutralColor = vec4(0.0, 0.0, 0.0, 1.0);

  if(depth <= range[0]) {
    near_color = texColor;
    // focus_color = neutralColor;
    far_color = neutralColor;
  }

  if(depth > range[0] && depth <= range[1]) {
    near_color = texColor;
    // focus_color = texColor;
    far_color =  neutralColor;
  }

  if(depth > range[1] && depth <= range[2]) {
    near_color = neutralColor;
    // focus_color = texColor;
    far_color = neutralColor;
  }

  if(depth > range[2] && depth <= range[3]) {
    near_color = neutralColor;
    // focus_color = texColor;
    far_color = texColor;
  }

  if(depth > range[3]) {
    near_color = neutralColor;
    // focus_color = neutralColor;
    far_color = texColor;
  }
}
