#version 330

in vec2 textPos;

uniform sampler2D depthTexture;

uniform sampler2D nearTexture;
uniform sampler2D focusTexture;
uniform sampler2D farTexture;

uniform vec4 range;

uniform float near_plane;
uniform float far_plane;

out vec4 color;

float linearDepth(float d)
{
  return (2 * near_plane) / (far_plane + near_plane - d * (far_plane - near_plane));
}

void main()
{

  float depth = linearDepth(texture(depthTexture, textPos).r) * 2.0 - 1.0;

  //vec4 nColor = texture(nearTexture, textPos);

  if(depth <= range[0]) {
    color = texture(nearTexture, textPos);
  }

  if(depth > range[0] && depth <= range[1]) {
    vec4 tc = mix(texture(nearTexture, textPos), texture(focusTexture, textPos), (depth - range[0]) / (range[1] - range[0]));
    color = tc;
  }

  if(depth > range[1] && depth <= range[2]) {
    //color = vec4(nColor.rgb * nColor.a + texture(focusTexture, textPos).rgb * (1 - nColor.a), 1);
    color = texture(focusTexture, textPos);
  }

  if(depth > range[2] && depth <= range[3]) {
    vec4 tc = mix(texture(focusTexture, textPos), texture(farTexture, textPos), (depth - range[2]) / (range[3] - range[2]));
    //color = vec4(nColor.rgb * nColor.a + tc.rgb * (1 - nColor.a), 1);
    color = tc;
  }

  if(depth > range[3]) {
    //color = vec4(nColor.rgb * nColor.a + texture(farTexture, textPos).rgb * (1 - nColor.a), 1);
    color = texture(farTexture, textPos);//.rgb * (1 - nColor.a), 1);
  }
}
