#version 330

in vec2 textPos;
in vec2 textPos_Offset[14];

uniform sampler2D colorTexture;
uniform sampler2D depthTexture;

uniform float near_plane;
uniform float far_plane;

uniform float radius;

float linearDepth(float d)
{
  return (2 * near_plane) / (far_plane + near_plane - d * (far_plane - near_plane));
}

void main()
{

    float origin_depth = linearDepth(texture(depthTexture, textPos).r) * 2.0 - 1.0;
    vec4 origin_color = texture(colorTexture, textPos);


    float sample_depth[14];
    sample_depth[ 0] = linearDepth(texture(depthTexture, textPos_Offset[ 0]).r) * 2.0 - 1.0;
    sample_depth[ 1] = linearDepth(texture(depthTexture, textPos_Offset[ 1]).r) * 2.0 - 1.0;
    sample_depth[ 2] = linearDepth(texture(depthTexture, textPos_Offset[ 2]).r) * 2.0 - 1.0;
    sample_depth[ 3] = linearDepth(texture(depthTexture, textPos_Offset[ 3]).r) * 2.0 - 1.0;
    sample_depth[ 4] = linearDepth(texture(depthTexture, textPos_Offset[ 4]).r) * 2.0 - 1.0;
    sample_depth[ 5] = linearDepth(texture(depthTexture, textPos_Offset[ 5]).r) * 2.0 - 1.0;
    sample_depth[ 6] = linearDepth(texture(depthTexture, textPos_Offset[ 6]).r) * 2.0 - 1.0;
    sample_depth[ 7] = linearDepth(texture(depthTexture, textPos_Offset[ 7]).r) * 2.0 - 1.0;
    sample_depth[ 8] = linearDepth(texture(depthTexture, textPos_Offset[ 8]).r) * 2.0 - 1.0;
    sample_depth[ 9] = linearDepth(texture(depthTexture, textPos_Offset[ 9]).r) * 2.0 - 1.0;
    sample_depth[10] = linearDepth(texture(depthTexture, textPos_Offset[10]).r) * 2.0 - 1.0;
    sample_depth[11] = linearDepth(texture(depthTexture, textPos_Offset[11]).r) * 2.0 - 1.0;
    sample_depth[12] = linearDepth(texture(depthTexture, textPos_Offset[12]).r) * 2.0 - 1.0;
    sample_depth[13] = linearDepth(texture(depthTexture, textPos_Offset[13]).r) * 2.0 - 1.0;

    gl_FragColor = vec4(0.0);



    gl_FragColor += texture(colorTexture, textPos) * 0.154009588968318;

    if (abs(origin_depth - sample_depth[ 6]) < radius)
    {
      gl_FragColor += texture(colorTexture, textPos_Offset[ 6]) * 0.143029423732574;

      if (abs(origin_depth - sample_depth[ 5]) < radius)
      {
        gl_FragColor += texture(colorTexture, textPos_Offset[ 5]) * 0.114566664736202;

        if (abs(origin_depth - sample_depth[ 4]) < radius)
        {
          gl_FragColor += texture(colorTexture, textPos_Offset[ 4]) * 0.079149177382765;

          if (abs(origin_depth - sample_depth[ 3]) < radius)
          {
            gl_FragColor += texture(colorTexture, textPos_Offset[ 3]) * 0.047161737320159;

            if (abs(origin_depth - sample_depth[ 2]) < radius)
            {
              gl_FragColor += texture(colorTexture, textPos_Offset[ 2]) * 0.024237534414825;

              if (abs(origin_depth - sample_depth[ 1]) < radius)
              {
                gl_FragColor += texture(colorTexture, textPos_Offset[ 1]) * 0.010743414616120;

                if (abs(origin_depth - sample_depth[ 0]) < radius)
                {
                  gl_FragColor += texture(colorTexture, textPos_Offset[ 0]) * 0.004107253313194;
                }
                else
                {
                  gl_FragColor += origin_color * 0.004107253313194;
                }
              }
              else
              {
                gl_FragColor += origin_color * (0.010743414616120 + 0.004107253313194);
              }
            }
            else
            {
              gl_FragColor += origin_color * (0.024237534414825
                + 0.010743414616120 + 0.004107253313194);
            }
          }
          else
          {
            gl_FragColor += origin_color * (0.047161737320159 + 0.024237534414825
              + 0.010743414616120 + 0.004107253313194);
          }
        }
        else
        {
          gl_FragColor += origin_color * (0.079149177382765
            + 0.047161737320159 + 0.024237534414825
            + 0.010743414616120 + 0.004107253313194);
        }
      }
      else
      {
        gl_FragColor += origin_color * (0.114566664736202 + 0.079149177382765
          + 0.047161737320159 + 0.024237534414825
          + 0.010743414616120 + 0.004107253313194);
      }
    }
    else
    {
      gl_FragColor += origin_color * (0.143029423732574
        + 0.114566664736202 + 0.079149177382765
        + 0.047161737320159 + 0.024237534414825
        + 0.010743414616120 + 0.004107253313194);
    }

    if (abs(origin_depth - sample_depth[ 7]) < radius)
    {
      gl_FragColor += texture(colorTexture, textPos_Offset[ 7]) * 0.143029423732574;

      if (abs(origin_depth - sample_depth[ 8]) < radius)
      {
        gl_FragColor += texture(colorTexture, textPos_Offset[ 8]) * 0.114566664736202;

        if (abs(origin_depth - sample_depth[ 9]) < radius)
        {
          gl_FragColor += texture(colorTexture, textPos_Offset[ 9]) * 0.079149177382765;

          if (abs(origin_depth - sample_depth[10]) < radius)
          {
            gl_FragColor += texture(colorTexture, textPos_Offset[10]) * 0.047161737320159;

            if (abs(origin_depth - sample_depth[11]) < radius)
            {
              gl_FragColor += texture(colorTexture, textPos_Offset[11]) * 0.024237534414825;

              if (abs(origin_depth - sample_depth[12]) < radius)
              {
                gl_FragColor += texture(colorTexture, textPos_Offset[12]) * 0.010743414616120;

                if (abs(origin_depth - sample_depth[13]) < radius)
                {
                  gl_FragColor += texture(colorTexture, textPos_Offset[13]) * 0.004107253313194;
                }
                else
                {
                  gl_FragColor += origin_color * 0.004107253313194;
                }
              }
              else
              {
                gl_FragColor += origin_color * (0.010743414616120 + 0.004107253313194);
              }
            }
            else
            {
              gl_FragColor += origin_color * (0.024237534414825
                + 0.010743414616120 + 0.004107253313194);
            }
          }
          else
          {
            gl_FragColor += origin_color * (0.047161737320159 + 0.024237534414825
              + 0.010743414616120 + 0.004107253313194);
          }
        }
        else
        {
          gl_FragColor += origin_color * (0.079149177382765
            + 0.047161737320159 + 0.024237534414825
            + 0.010743414616120 + 0.004107253313194);
        }
      }
      else
      {
        gl_FragColor += origin_color * (0.114566664736202 + 0.079149177382765
          + 0.047161737320159 + 0.024237534414825
          + 0.010743414616120 + 0.004107253313194);
      }
    }
    else
    {
      gl_FragColor += origin_color * (0.143029423732574
        + 0.114566664736202 + 0.079149177382765
        + 0.047161737320159 + 0.024237534414825
        + 0.010743414616120 + 0.004107253313194);
    }

  }
