#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;

uniform mat4 modelMatrix;
uniform mat4 MVMatrix;
uniform mat4 MVPMatrix;
uniform mat4 NormalMVMatrix;
uniform mat4 normalMatrix;
uniform mat4 lightMVP;

out vec4 positionFrag;
out vec4 viewPositionFrag;
out vec4 normalFrag;
out vec3 normalVFrag;
out vec2 uvFrag;

// coordinates in the ShadowMap
out vec4 SM_tex_coord;

void main()
{
	positionFrag = modelMatrix * vec4(position, 1.0);
	viewPositionFrag = (MVMatrix * vec4(position, 1.0));
	normalFrag = vec4(normalize(mat3(normalMatrix) * normal), 0.0);
	normalVFrag = (NormalMVMatrix * vec4(normal, 1)).rgb;
	uvFrag = uv;

	SM_tex_coord = lightMVP * vec4(position, 1.0);

	gl_Position = MVPMatrix * vec4(position, 1.0);
}
